// Licence GNU
// ROAM algoritmus pro generovani 3D krajiny
// Autor: Pavel ern (xcerny19)
// Vypracovno jako ronkov projekt na FIT.VUTBR

// Implementace main funkce pro Windows.
// Pouv knihovnu SoWin.
//



#include <Inventor/Win/SoWin.h>
#include <Inventor/Win/viewers/SoWinExaminerViewer.h>
#include <Inventor/nodes/SoSeparator.h>


// Pro linker: Budeme linkovat s main,
// nikoliv WinMain, jak je na Windows zvykem
#pragma comment(linker, "/entry:\"mainCRTStartup\"")


extern SoSeparator* createScene(int argc, char **argv);
extern const char *appTitle;
extern bool headlight;
extern SoWinExaminerViewer *viewer;

int main(int argc, char **argv)
{
  // nastav nkter promnn prosted:
  // - IV_SEPARATOR_MAX_CACHES=0 vypn cachovn do display-list
  //   (ovlivuje men vkonnosti)
  // - COIN_SHOW_FPS_COUNTER=1 zobraz mi FPS
  putenv("IV_SEPARATOR_MAX_CACHES=0");
  putenv("COIN_SHOW_FPS_COUNTER=1"); 

  // Inicializuj Inventor
  HWND window = SoWin::init(argv[0]);
  if (window == NULL) exit(1);

  // Vytvo okno prohlee
  viewer = new SoWinExaminerViewer(window);
  viewer->setHeadlight(headlight);
  viewer->setTitle(appTitle);
  viewer->show();

  // Vytvo koen scny
  SoSeparator *root = createScene(argc, argv);
  root->ref();


  // Zobraz okna a rozje renderovac smyku
  SoWin::show(window);
  SoWin::mainLoop();

  // Uvolni pam
  delete viewer;
  root->unref();

  return 0;
}
